"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types = require("@babel/types");
const NodeGenerator_1 = require("../helpers/NodeGenerator");
class BooleanLiteralMutator {
    constructor() {
        this.name = 'BooleanLiteral';
        this.unaryBooleanPrefix = '!';
    }
    mutate(node) {
        // true -> false or false -> true
        if (types.isBooleanLiteral(node)) {
            return [[node, NodeGenerator_1.NodeGenerator.createMutatedCloneWithProperties(node, { value: !node.value })]];
        }
        else if (types.isUnaryExpression(node) && node.operator === this.unaryBooleanPrefix && node.prefix) {
            return [[node, node.argument]];
        }
        return [];
    }
}
exports.default = BooleanLiteralMutator;
//# sourceMappingURL=BooleanLiteralMutator.js.map